#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>
#include <inttypes.h>
#include <pthread.h>
#include <string.h>
#include <sys/time.h>

#include "config.h"
#include "defines.h"

extern uint64_t  atime_stamp;


int v_mkvwrite(void)
{
	void *ptr;
	int offset,i;

	uint64_t time_stamp=
		(uint64_t)((state->this_frame_params.timestamp_usec - state->frame_params.timestamp_usec)+
			1000000*(state->this_frame_params.timestamp_sec  - state->frame_params.timestamp_sec));
#if 0
	if(state->head_size+state->jpeg_len+TRAILER_SIZE+state->exifSize > state->bufSize) {
		if((ptr=realloc(state->jpegBuffer, state->head_size+state->jpeg_len+TRAILER_SIZE+state->exifSize)) != NULL)
			state->jpegBuffer=ptr;
		else {
			DBG(0,"Can't realloc memory buffer, size %d!\n",state->head_size+state->jpeg_len+TRAILER_SIZE);
			return -1;
		}
	}
#endif
	offset=0;
	for(i=1; i<state->chunk_index; i++) {
		memcpy(state->jpegBuffer+offset,state->packetchunks[i].chunk,state->packetchunks[i].bytes);
		offset+=state->packetchunks[i].bytes;
	}
	// write video frames to mkv
	DBG(3, "Writing video chunk data\n");
	if( mk_startFrame(state->mkv_file, state->vtrack) < 0)
	{
		DBG(0, "Failed to write video frame to output file.\n" );
		return -1;
	}
	mk_addFrameData(state->mkv_file, state->vtrack, state->jpegBuffer, offset);  
//			state->head_size+state->jpeg_len+state->exifSize+TRAILER_SIZE);
	mk_setFrameFlags(state->mkv_file, state->vtrack, (uint64_t)(time_stamp*1000), 
			1, 0 /*(uint64_t)(time_stamp*1000)*/ );
return 0;
}

int a_mkvwrite(void)
{

	DBG(3, "Writing audio chunk data\n");
	if( mk_startFrame(state->mkv_file, state->atrack) < 0)
	{
		DBG(0, "Failed to write audio frame to MKV\n" );
		return -1;
	}
	mk_addFrameData(state->mkv_file, state->atrack, state->audiobuf, state->chunk_bytes ); 
	mk_setFrameFlags(state->mkv_file, state->atrack, (uint64_t)(atime_stamp*1000), 
			1, 0 );
	atime_stamp+=state->period_time;

return 0;	
}

int dvr_mkvopen(void)
{
	mk_TrackConfig 	      *track;

	DBG(3,"Trying open MKV file\n");
	track = calloc(1, sizeof(mk_TrackConfig));
	if(track == NULL)
		return -1;
	sprintf(state->path,"%s%010ld_%06ld.mkv",state->path_prefix,
			state->this_frame_params.timestamp_sec,state->this_frame_params.timestamp_usec);
	DBG(3,"MKV: path= %s audio_enabled=%d\n", state->path,state->audio_enabled);

	state->mkv_file = mk_createWriter(state->path, TIMESCALE, 1);
	if( !(state->mkv_file) )
	{
		DBG(0,"Could not create output MKV file: \n" );
		if(track != NULL)
			free(track);
		return -1;
	}

	state->chapter_no=0;

	/* Video track */
	bzero((void *)&(state->vpic), sizeof(alBITMAPINFOHEADER));
	state->vpic.bi_size=sizeof(alBITMAPINFOHEADER);
	state->vpic.bi_width = state->width;
	state->vpic.bi_height= state->height;
	state->vpic.bi_planes=1;
	//vpic.bi_bit_count=24;   //for JPEG
	state->vpic.bi_compression=0x4745504A; // JPEG picture 
	state->vpic.bi_size_image=0;//jpeg_len??? //maxFrameSize;
	track->trackType = MK_TRACK_VIDEO;
	track->flagDefault = 1;
	track->flagEnabled = 1;
	track->flagLacing = 0;
	track->codecID = VCODEC_FOURCC;
	track->codecPrivate = &(state->vpic);
	track->codecPrivateSize = sizeof(alBITMAPINFOHEADER);

	track->extra.video.pixelWidth 	= state->vpic.bi_width;
	track->extra.video.pixelHeight 	= state->vpic.bi_height;
	track->extra.video.displayHeight= state->vpic.bi_height;
	track->extra.video.displayWidth = state->vpic.bi_width;

	track->defaultDuration = (uint64_t)(state->frame_period*1000); // ie  40000000 - for 25 fps 
	state->vtrack = mk_createTrack(state->mkv_file, track);
	//memcpy(&state->frame_params, &state->this_frame_params, sizeof(state->frame_params));

	DBG(3,"Set MKV audio parameters if enabled(%d)\n",state->audio_enabled);
	if(state->audio_enabled) {
		DBG(3,"Set MKV audio parameters\n");
		//audio track
		memset(track, 0, sizeof(mk_TrackConfig));
		track->codecPrivate = NULL;
		track->codecPrivateSize = 0;
		track->codecID = MK_ACODEC_PCMINTLE;
		track->flagDefault = 1;
		track->flagEnabled = 1;
		track->trackType = MK_TRACK_AUDIO;
		track->language = "und";
		track->extra.audio.samplingFreq = (float)state->rate; //48000.;
		track->extra.audio.channels = state->channels;
		track->extra.audio.bitDepth = state->bitDepth;
		track->defaultDuration = 0; // not needed 
		track->flagLacing = 1;
		state->atrack = mk_createTrack(state->mkv_file, track);
	}
	if(track != NULL) free(track);
	if( mk_writeHeader( state->mkv_file, "DVR MKV Elphel: "PACKAGE "ver " VERSION ) < 0 ) {
		DBG(0, "Failed to create output MKV file.\n");
		return -1;
	}
	
return 0;
}

int dvr_mkvreset(void)
{
	char		buffer[128];
	uint64_t     	time_stamp=(uint64_t)((state->this_frame_params.timestamp_usec - state->frame_params.timestamp_usec)+
			1000000*(state->this_frame_params.timestamp_sec  - state->frame_params.timestamp_sec));

	state->chapter_no++;
	mk_flushFrame(state->mkv_file, state->vtrack);
	if(state->audio_enabled) 
		mk_flushFrame(state->mkv_file, state->atrack);
	sprintf( buffer, "Chapter %02d",state->chapter_no );
	mk_createChapterSimple(state->mkv_file, 0 ,(uint64_t)(time_stamp*1000), buffer);
	state->segment_length=state->segment_length_s;     	

return 0;
}


int dvr_mkvclose(void)
{
	dvr_mkvreset();
	mk_close(state->mkv_file);
        state->mkv_file=NULL;	
return 0;
}

//int dvr_mkvfree(void)
//{
//return 0;	
//}


